#include "init.h"
#include "stm8s.h"
#include "leds.h"
#include "timebase.h"
#include "motor.h"
#include "control.h"
#include "light_sensor.h"
#include <stdbool.h>

#define MIN_MOVE_TIME 600 //          ()

extern volatile uint8_t ir_rx_buffer[4];
extern volatile uint8_t new_data_flag;

bool open_sensor = false;
bool close_sensor = false;

extern bool strong_light;//   , true   
extern bool quick_strong_light;//   , true   
extern bool new_light_data;// ,    

extern Motor_Pos_Type cur_motor_pos;
extern Motor_Status_Type motor_status;// 

Auto_Status_Type auto_mode = MANUAL;

uint16_t movment_time = 0;

bool sensor_on = false; // 
bool ac_dc_on = false;//  



void tsop_handler(void)
{
  if (new_data_flag == 1)
  {
    switch (ir_rx_buffer[2])
    {
      case (0xF4):
        start_drive(CMD_OPEN, 300,false);
        movment_time = 0;
        break;
      case (0xD8):
        start_drive(CMD_CLOSE, 300,false);
        movment_time = 0;
        break;
      case (0x98):
        start_drive(CMD_CLOSE, 20000,true);
        movment_time = 0;
        break;
      case (0xD0):
        start_drive(CMD_OPEN, 20000,true);
        movment_time = 0;
        break;
      case (0xA0):
        stop_motor();
        break;
      case (0xD4):
        run_motor_by_light_value();
        break;
        
     case (0xA4):
       while(1) {asm("nop");}//      
        break; 
        
      default: break; 

    }
    new_data_flag = 0;
  }

}

void light_control_handler(void)
{
  bool result = false;
  Drive_Command_Type cmd;
  
  set_auto_mode();
  check_motor_power();
  
  if (new_light_data == true)
  {
    new_light_data = false;
    
    movment_time++;//  
    
    if (movment_time > MIN_MOVE_TIME) {movment_time = MIN_MOVE_TIME+10;}//  
    
    if ((movment_time > MIN_MOVE_TIME) && (auto_mode == AUTO)) 
    {
      // 

      if (strong_light == true) {cmd = CMD_OPEN;} else {cmd = CMD_CLOSE;} //  - 
      result = auto_start_drive(cmd);
      if (result == true) {movment_time = 0;}// 
      //   ,   
    }
  }
}

//      ( )
//  /  
void run_motor_by_light_value(void)
{
  Drive_Command_Type cmd;
  bool result = false;
  
  if (sensor_on == false) {return;} //   ,   
  
  if (quick_strong_light == true) {cmd = CMD_OPEN;} else {cmd = CMD_CLOSE;} //  - 
  result = auto_start_drive(cmd);
  if (result == true) {movment_time = 0;}// 
  //   ,   
}

//   
void set_auto_mode(void)
{  
  Auto_Status_Type cur_auto_mode = MANUAL;
  
  check_sensor();
    
  if (GPIO_ReadInputPin(AUTO_PORT, AUTO_PIN) == RESET) {cur_auto_mode = AUTO;}// 
  //   -    MANUAL
  if (sensor_on == false) {cur_auto_mode = MANUAL;}//     
  if (ac_dc_on == false) {cur_auto_mode = MANUAL;}//     
  auto_mode = cur_auto_mode;
}

//,   
void check_sensor(void)
{
  uint16_t sval = 0;
  sval = get_adc_data(6);
  if (sval > 100) {sensor_on = false;} else {sensor_on = true;}
}

//,   
void check_motor_power(void)
{
  uint16_t sval = 0;
  sval = get_adc_data(4);
  if (sval > 700) {ac_dc_on = true;} else {ac_dc_on = false;}
}



