#include "init.h"
#include "stm8s_gpio.h"
#include "stm8s.h"
#include "leds.h"
#include "timebase.h"
#include <stdbool.h>
#include "motor.h"
#include "control.h"

extern volatile uint8_t new_data_flag;
extern bool power_on; //  
extern Motor_Status_Type motor_status;

extern bool sensor_on; // 
extern Auto_Status_Type auto_mode;
extern bool motor_fatal_error;// ,  
extern bool open_sensor;
extern bool close_sensor;

void enable_blue_led(void)
{
  GPIO_WriteHigh(LED1_PORT, LED1_PIN);
  GPIO_WriteLow(LED2_PORT, LED2_PIN);
}

void enable_red_led(void)
{
  GPIO_WriteLow(LED1_PORT, LED1_PIN);
  GPIO_WriteHigh(LED2_PORT, LED2_PIN);
}

void disable_leds(void)
{
  GPIO_WriteLow(LED1_PORT, LED1_PIN);
  GPIO_WriteLow(LED2_PORT, LED2_PIN);
}

void leds_handler(void)
{
  static uint8_t red_count = 0;
  uint8_t red_max = 0;
  static uint8_t red_status = 1;
  
  if (motor_status == MOTOR_RUNING) {GPIO_WriteHigh(LED1_PORT, LED1_PIN);} else {GPIO_WriteLow(LED1_PORT, LED1_PIN);}
  
  if (sensor_on == false) {red_max = 2;}//  
  if ((open_sensor == true) && (close_sensor == true)) {red_max = 4;}//  
  if (motor_fatal_error == true) {red_max = 3;}//
  
  
  if ((red_max > 0) && led_timer_elapsed())
  {
    if (red_count == red_max) {set_led_timer(600);} else {set_led_timer(250);}
    red_status^= 1;
    if (red_status == 0) {red_count++;}
  }
  
  if (red_max == 0) {red_status = 1;}
  
  if (red_count > red_max) {red_count = 0; red_status = 1;}
  
  if (red_status == 1) {GPIO_WriteLow(LED2_PORT, LED2_PIN);} else {GPIO_WriteHigh(LED2_PORT, LED2_PIN);}
}