#include "init.h"
#include "stm8s.h"
#include "leds.h"
#include "timebase.h"
#include "motor.h"
#include "light_sensor.h"
#include "stm8s_adc1.h"
#include <stdbool.h>

#define SAMPLES_N 600
#define SAMPLES_LEVEL 400//      (400/600 = 66% )

uint16_t light_data[SAMPLES_N];//     SAMPLES_N  
uint16_t light_data_cnt = 0;

uint16_t light_threshold = 260;// ,     

bool strong_light = false;//   , true   
bool new_light_data = false;// ,    

uint16_t quick_light = 0;//   
bool quick_strong_light = false;//   , true   

void light_sensor_handler(void)
{
  static uint16_t summ =0;
  static uint8_t cnt =0;
  
  if (sensor_timer_elapsed())
  {
    if (cnt < 10)
    {
      //   
      summ+= get_adc_data(1);
      cnt++;
    }
    else
    {
      cnt = 0;
      summ = summ/10;
      quick_light = summ;
      if (quick_light < light_threshold) {quick_strong_light = true;} else {quick_strong_light = false;}
      
      summ = 0;
      
      //  
      //uart_send_msg(quick_light);
      
      light_data_cnt++;
      if (light_data_cnt >= SAMPLES_N)  {light_data_cnt=0; }
      light_data[light_data_cnt] = quick_light;
      
      if (array_analyse() > SAMPLES_LEVEL) {strong_light = true;} else {strong_light = false;}
      
      new_light_data = true;
    }
    
    
    set_sensor_timer(100);
    
  }
  
}

//    
uint16_t array_analyse(void)
{
  uint16_t i;
  uint16_t cnt = 0;
  for (i=0;i<SAMPLES_N;i++)
  {
    if (light_data[i] < light_threshold) {cnt++;} //   
  }
  return cnt;
}

void init_light_buffer(void)
{
  uint16_t i;
  for (i=0;i<SAMPLES_N;i++){light_data[i] = 1000;}
}


void uart_send_byte(uint8_t data)
{
  UART2_SendData8(data);
  while (UART2_GetFlagStatus(UART2_FLAG_TXE) == RESET);
}


void uart_send_msg(uint16_t val)
{
  uart_send_byte(65);
  uart_send_byte((uint8_t)(val & 0x00FF));
  uart_send_byte((uint8_t)(val >> 8));
}

//    
uint16_t get_adc_data(uint8_t ADC1_Channel)
{
  uint16_t res = 0;
  
  ADC1_Cmd(DISABLE);
  ADC1->CSR &= (uint8_t)(~ADC1_CSR_CH);/* Clear the ADC1 channels */
  ADC1->CSR |= (uint8_t)(ADC1_Channel);/* Select the ADC1 channel */
  ADC1_Cmd(ENABLE);
  
  ADC1_ClearFlag(ADC1_FLAG_EOC);
  ADC1_StartConversion();
  while (ADC1_GetFlagStatus(ADC1_FLAG_EOC) == RESET){}
  

  ADC1_ClearFlag(ADC1_FLAG_EOC);
  ADC1_StartConversion();
  while (ADC1_GetFlagStatus(ADC1_FLAG_EOC) == RESET){}
  res = (ADC1_GetConversionValue());

  return res;
}