#include "timebase.h"
#include "stm8s.h"
#include "init.h"
#include <stdbool.h>


#define TIM4_OVR_UIF_vector                  0x19

volatile uint16_t delay_timer = 0;
volatile uint16_t tsop_timer = 0;
volatile uint16_t motor_timer = 0;
volatile uint16_t relay_timer = 0;
volatile uint16_t power_timer = 0;
volatile uint16_t sensor_timer = 0;
volatile uint16_t led_timer = 0;
volatile uint16_t button_timer = 0;

volatile uint16_t sens_counter = 0;
volatile uint16_t mes_time = 0;//    

volatile uint8_t sens_flag = 0;//  
volatile uint8_t updatae_flag = 0;

extern bool open_sensor;
extern bool close_sensor;


#pragma vector = TIM4_OVR_UIF_vector
__interrupt void base_timer(void)
{
  TIM4_ClearITPendingBit(TIM4_IT_UPDATE);
  if (delay_timer != 0) {delay_timer--;}
  if (tsop_timer != 0) {tsop_timer--;}
  if (motor_timer != 0) {motor_timer--;}
  if (relay_timer != 0) {relay_timer--;}
  if (power_timer != 0) {power_timer--;}
  if (sensor_timer != 0) {sensor_timer--;}
  if (led_timer != 0) {led_timer--;}
  if (button_timer != 0) {button_timer--;}
  
  if (GPIO_ReadInputPin(OPEN_SENSOR_PORT, OPEN_SENSOR_PIN) == RESET) {open_sensor = true;} else {open_sensor = false;}
  if (GPIO_ReadInputPin(CLOSE_SENSOR_PORT, CLOSE_SENSOR_PIN) == RESET) {close_sensor = true;} else {close_sensor = false;}
  
}

//   
void set_delay_timer(uint16_t value)
{
  delay_timer = value;
}

//   
void set_tsop_timer(uint16_t value)
{
  tsop_timer = value;
}

//   
void set_motor_timer(uint16_t value)
{
  motor_timer = value;
}

//   
void set_relay_timer(uint16_t value)
{
  relay_timer = value;
}

//   
void set_power_timer(uint16_t value)
{
  power_timer = value;
}

//   
void set_sensor_timer(uint16_t value)
{
  sensor_timer = value;
}

//   
void set_led_timer(uint16_t value)
{
  led_timer = value;
}

//   
void set_button_timer(uint16_t value)
{
  button_timer = value;
}



//*****************************************************************************


//
bool delay_timer_elapsed(void)
{
  asm("nop");
  
  if (delay_timer == 0) 
  {
    asm("nop");
    return TRUE;
  } 
  else 
  {
    asm("nop");
    return FALSE;
  }
  
  
}


//
bool tsop_timer_elapsed(void)
{
  if (tsop_timer == 0) {return TRUE;} else {return FALSE;}
}

//
bool motor_timer_elapsed(void)
{
  if (motor_timer == 0) {return TRUE;} else {return FALSE;}
}

//
bool relay_timer_elapsed(void)
{
  if (relay_timer == 0) {return TRUE;} else {return FALSE;}
}

//
bool power_timer_elapsed(void)
{
  if (power_timer == 0) {return TRUE;} else {return FALSE;}
}

//
bool led_timer_elapsed(void)
{
  if (led_timer == 0) {return TRUE;} else {return FALSE;}
}

//
bool sensor_timer_elapsed(void)
{
  if (sensor_timer == 0) {return TRUE;} else {return FALSE;}
}

//
bool button_timer_elapsed(void)
{
  if (button_timer == 0) {return TRUE;} else {return FALSE;}
}


void delay(uint16_t time)
{
  set_delay_timer(time);
  while (delay_timer_elapsed() == FALSE)
  {
    asm("nop");
  }
}



