#include "init.h"
#include "stm8s_gpio.h"
#include "stm8s.h"
#include "leds.h"
#include "timebase.h"

//#include "iostm8s105s4.h"
#define TIM1_CAPCOM_CC2IF_vector             0x0E

volatile uint8_t ir_rx_buffer[4];
volatile uint8_t step;//   
volatile uint8_t number;//  
volatile uint8_t new_data_flag = 0;
volatile uint8_t rx_enable = 0;

#define IR_START_LENGTH   120 //7.68ms
#define IR_ONE_LENGTH     20 //1.28ms
#define IR_REPEAT_LENGTH  30 

#pragma vector = TIM1_CAPCOM_CC2IF_vector
__interrupt void tsop_timer_int(void)
{
    uint16_t time;
    uint8_t tmp;
    
    if(TIM1_GetFlagStatus(TIM1_FLAG_CC2))
    {
      time = TIM1_GetCapture2();

	//   
	if (time > IR_START_LENGTH)
	{
	    number = 0;
	    step = 1;
            rx_enable = 1;
	}
        else if (rx_enable == 1)
	{
          if ((time > IR_REPEAT_LENGTH) && (number == 0) && (!tsop_timer_elapsed()))
          {
            // 
            new_data_flag = 1;
            set_tsop_timer(300);//   100 ,        0
          }
            
	  if (step & (1<<7))
	  {
	    step <<= 1;
	    if (time > IR_ONE_LENGTH){step|= 1;}

	    ir_rx_buffer[number] = step;
            if (number < 3) {number++;}
            else
            {
              tmp = ir_rx_buffer[3]^255;
              if (ir_rx_buffer[2] == tmp) // 
              {
                new_data_flag = 1;
                set_tsop_timer((uint16_t)300);
                rx_enable = 0;
                //     
              }
             
            }
            step = 1;
          }
	  else
	  {
	    step <<= 1;
	    if (time > IR_ONE_LENGTH){step |= 1;}
	  }
        }

        //  
	TIM1_ClearITPendingBit(TIM1_IT_CC2);
    }    
    
}